Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 1321)
+++ /palm/trunk/SOURCE/Makefile	(revision 1322)
@@ -269,5 +269,5 @@
 diffusivities.o: modules.o mod_kinds.o
 disturb_field.o: modules.o cpulog.o mod_kinds.o random_function.o
-disturb_heatflux.o: modules.o mod_kinds.o
+disturb_heatflux.o: modules.o cpulog.o mod_kinds.o
 eqn_state_seawater.o: modules.o mod_kinds.o
 exchange_horiz.o: modules.o cpulog.o mod_kinds.o
Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1321)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-!
+! REAL constants defined as wp-kind
 !
 ! Former revisions:
@@ -195,10 +195,10 @@
 !
 !--    Set the appropriate factors for scalar and momentum advection.
-       adv_sca_5 = 1./60.
-       adv_sca_3 = 1./12.
-       adv_sca_1 = 1./2.
-       adv_mom_5 = 1./120.
-       adv_mom_3 = 1./24.
-       adv_mom_1 = 1./4.
+       adv_sca_5 = 1.0_wp /  60.0_wp
+       adv_sca_3 = 1.0_wp /  12.0_wp
+       adv_sca_1 = 1.0_wp /   2.0_wp
+       adv_mom_5 = 1.0_wp / 120.0_wp
+       adv_mom_3 = 1.0_wp /  24.0_wp
+       adv_mom_1 = 1.0_wp /   4.0_wp
 !         
 !--    Arrays needed for statical evaluation of fluxes.
@@ -1174,8 +1174,8 @@
                               + ( flux_r(k) *                                 &
                                 ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
-                              / ( u_comp(k) - gu + 1.0E-20      )             &
+                              / ( u_comp(k) - gu + 1.0E-20_wp   )             &
                               +   diss_r(k) *                                 &
                                   ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
-                              / ( ABS( u_comp(k) - gu ) + 1.0E-20 ) )         &
+                              / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp ) )      &
                               *   weight_substep(intermediate_timestep_count)
 !
@@ -1278,8 +1278,8 @@
                               + ( flux_r(k) *                                 &
                                 ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
-                              / ( u_comp(k) - gu + 1.0E-20      )             &
+                              / ( u_comp(k) - gu + 1.0E-20_wp   )             &
                               +   diss_r(k) *                                 &
                                   ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
-                              / ( ABS( u_comp(k) - gu ) + 1.0E-20 ) )         &
+                              / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp ) )      &
                               *   weight_substep(intermediate_timestep_count)
 !
@@ -1631,8 +1631,8 @@
              + ( flux_n(k)                                                    &
              * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                             &
-             / ( v_comp(k) - gv + 1.0E-20 )                                   &
+             / ( v_comp(k) - gv + 1.0E-20_wp )                                &
              +   diss_n(k)                                                    &
              *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )                        &
-             / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )                           &
+             / ( ABS( v_comp(k) - gv ) +1.0E-20_wp ) )                        &
              *   weight_substep(intermediate_timestep_count)
 !
@@ -1740,8 +1740,8 @@
              + ( flux_n(k)                                                    &
              * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                             &
-             / ( v_comp(k) - gv + 1.0E-20 )                                   &
+             / ( v_comp(k) - gv + 1.0E-20_wp )                                &
              +   diss_n(k)                                                    &
              *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )                        &
-             / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )                           &
+             / ( ABS( v_comp(k) - gv ) +1.0E-20_wp ) )                        &
              *   weight_substep(intermediate_timestep_count)
 !
@@ -3312,8 +3312,8 @@
                               + ( flux_r(k) *                                 &
                                 ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
-                              / ( u_comp(k) - gu + 1.0E-20      )             &
+                              / ( u_comp(k) - gu + 1.0E-20_wp    )            &
                               +   diss_r(k) *                                 &
                                   ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
-                              / ( ABS( u_comp(k) - gu ) + 1.0E-20 ) )         &
+                              / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp ) )      &
                               *   weight_substep(intermediate_timestep_count)
 !
@@ -3418,8 +3418,8 @@
                               + ( flux_r(k) *                                 &
                                 ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
-                              / ( u_comp(k) - gu + 1.0E-20      )             &
+                              / ( u_comp(k) - gu + 1.0E-20_wp   )             &
                               +   diss_r(k) *                                 &
                                   ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
-                              / ( ABS( u_comp(k) - gu ) + 1.0E-20 ) )         &
+                              / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp ) )      &
                               *   weight_substep(intermediate_timestep_count)
 !
@@ -3749,8 +3749,8 @@
 !                              + ( flux_r    *                                 &
 !                                ( u_comp    - 2.0 * hom(k,1,1,0) )            &
-!                              / ( u_comp    - gu + 1.0E-20      )             &
+!                              / ( u_comp    - gu + 1.0E-20_wp   )             &
 !                              +   diss_r    *                                 &
 !                                  ABS( u_comp    - 2.0 * hom(k,1,1,0) )       &
-!                              / ( ABS( u_comp    - gu ) + 1.0E-20 ) )         &
+!                              / ( ABS( u_comp    - gu ) + 1.0E-20_wp ) )      &
 !                              *   weight_substep(intermediate_timestep_count)
 !
@@ -4108,8 +4108,8 @@
                       + ( flux_n(k)                                           &
                       * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                    &
-                      / ( v_comp(k) - gv + 1.0E-20 )                          &
+                      / ( v_comp(k) - gv + 1.0E-20_wp )                       &
                       +   diss_n(k)                                           &
                       *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )               &
-                      / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )                  &
+                      / ( ABS( v_comp(k) - gv ) +1.0E-20_wp ) )               &
                       *   weight_substep(intermediate_timestep_count)
 !
@@ -4221,8 +4221,8 @@
                          + ( flux_n(k)                                        &
                          * ( v_comp(k) - 2.0 * hom(k,1,2,0) )                 &
-                         / ( v_comp(k) - gv + 1.0E-20 )                       &
+                         / ( v_comp(k) - gv + 1.0E-20_wp )                    &
                          +   diss_n(k)                                        &
                          *   ABS( v_comp(k) - 2.0 * hom(k,1,2,0) )            &
-                         / ( ABS( v_comp(k) - gv ) +1.0E-20 ) )               &
+                         / ( ABS( v_comp(k) - gv ) +1.0E-20_wp ) )            &
                          *   weight_substep(intermediate_timestep_count)
 !
@@ -4554,8 +4554,8 @@
 !                      + ( flux_n                                           &
 !                      * ( v_comp - 2.0 * hom(k,1,2,0) )                    &
-!                      / ( v_comp - gv + 1.0E-20 )                          &
+!                      / ( v_comp - gv + 1.0E-20_wp )                       &
 !                      +   diss_n                                           &
 !                      *   ABS( v_comp - 2.0 * hom(k,1,2,0) )               &
-!                      / ( ABS( v_comp - gv ) +1.0E-20 ) )                  &
+!                      / ( ABS( v_comp - gv ) +1.0E-20_wp ) )               &
 !                      *   weight_substep(intermediate_timestep_count)
 !
Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 1321)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL functions provided with KIND-attribute
 !
 ! Former revisions:
@@ -99,5 +99,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      e_av(k,j,i) = e_av(k,j,i) / REAL( average_count_3d )
+                      e_av(k,j,i) = e_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -107,5 +107,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   qsws_av(j,i) = qsws_av(j,i) / REAL( average_count_3d )
+                   qsws_av(j,i) = qsws_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
@@ -115,5 +115,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      lpt_av(k,j,i) = lpt_av(k,j,i) / REAL( average_count_3d )
+                      lpt_av(k,j,i) = lpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -123,5 +123,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   lwp_av(j,i) = lwp_av(j,i) / REAL( average_count_3d )
+                   lwp_av(j,i) = lwp_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
@@ -131,5 +131,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      nr_av(k,j,i) = nr_av(k,j,i) / REAL( average_count_3d )
+                      nr_av(k,j,i) = nr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -140,5 +140,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      p_av(k,j,i) = p_av(k,j,i) / REAL( average_count_3d )
+                      p_av(k,j,i) = p_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -149,5 +149,5 @@
                 DO  j = nys, nyn
                    DO  k = nzb, nzt+1
-                      pc_av(k,j,i) = pc_av(k,j,i) / REAL( average_count_3d )
+                      pc_av(k,j,i) = pc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -158,5 +158,5 @@
                 DO  j = nys, nyn
                    DO  k = nzb, nzt+1
-                      pr_av(k,j,i) = pr_av(k,j,i) / REAL( average_count_3d )
+                      pr_av(k,j,i) = pr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -167,5 +167,5 @@
                 DO  j = nysg, nyng
                    precipitation_rate_av(j,i) = precipitation_rate_av(j,i) /   &
-                                                REAL( average_count_3d )
+                                                REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
@@ -175,5 +175,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d )
+                      pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -184,5 +184,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d )
+                      q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -193,5 +193,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      qc_av(k,j,i) = qc_av(k,j,i) / REAL( average_count_3d )
+                      qc_av(k,j,i) = qc_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -202,5 +202,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      ql_av(k,j,i) = ql_av(k,j,i) / REAL( average_count_3d )
+                      ql_av(k,j,i) = ql_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -211,5 +211,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      ql_c_av(k,j,i) = ql_c_av(k,j,i) / REAL( average_count_3d )
+                      ql_c_av(k,j,i) = ql_c_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -220,5 +220,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      ql_v_av(k,j,i) = ql_v_av(k,j,i) / REAL( average_count_3d )
+                      ql_v_av(k,j,i) = ql_v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -230,5 +230,5 @@
                    DO  k = nzb, nzt+1
                       ql_vp_av(k,j,i) = ql_vp_av(k,j,i) /                      &
-                                        REAL( average_count_3d )
+                                        REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -239,5 +239,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      qr_av(k,j,i) = qr_av(k,j,i) / REAL( average_count_3d )
+                      qr_av(k,j,i) = qr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -248,5 +248,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      qv_av(k,j,i) = qv_av(k,j,i) / REAL( average_count_3d )
+                      qv_av(k,j,i) = qv_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -257,5 +257,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      rho_av(k,j,i) = rho_av(k,j,i) / REAL( average_count_3d )
+                      rho_av(k,j,i) = rho_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -266,5 +266,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      s_av(k,j,i) = s_av(k,j,i) / REAL( average_count_3d )
+                      s_av(k,j,i) = s_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -275,5 +275,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      sa_av(k,j,i) = sa_av(k,j,i) / REAL( average_count_3d )
+                      sa_av(k,j,i) = sa_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -283,5 +283,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   shf_av(j,i) = shf_av(j,i) / REAL( average_count_3d )
+                   shf_av(j,i) = shf_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
@@ -290,5 +290,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   ts_av(j,i) = ts_av(j,i) / REAL( average_count_3d )
+                   ts_av(j,i) = ts_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
@@ -298,5 +298,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d )
+                      u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -306,5 +306,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   us_av(j,i) = us_av(j,i) / REAL( average_count_3d )
+                   us_av(j,i) = us_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
@@ -314,5 +314,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d )
+                      v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -323,5 +323,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      vpt_av(k,j,i) = vpt_av(k,j,i) / REAL( average_count_3d )
+                      vpt_av(k,j,i) = vpt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -332,5 +332,5 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d )
+                      w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -340,5 +340,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   z0_av(j,i) = z0_av(j,i) / REAL( average_count_3d )
+                   z0_av(j,i) = z0_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
@@ -347,5 +347,5 @@
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
-                   z0h_av(j,i) = z0h_av(j,i) / REAL( average_count_3d )
+                   z0h_av(j,i) = z0h_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
              ENDDO
Index: /palm/trunk/SOURCE/calc_radiation.f90
===================================================================
--- /palm/trunk/SOURCE/calc_radiation.f90	(revision 1321)
+++ /palm/trunk/SOURCE/calc_radiation.f90	(revision 1322)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! exponent 4.0 changed to integer
 !
 ! Former revisions:
@@ -127,5 +127,5 @@
 
              temperature     = pt(nzb,j,i) * t_d_pt(nzb) + l_d_cp * ql(nzb,j,i)
-             blackbody_emission(nzb) = sigma * temperature**4.0
+             blackbody_emission(nzb) = sigma * temperature**4
 
              DO  k = nzb_2d(j,i)+1, nzt
@@ -139,5 +139,5 @@
 
                 temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
-                blackbody_emission(k) = sigma * temperature**4.0
+                blackbody_emission(k) = sigma * temperature**4
 
              ENDDO
@@ -149,5 +149,5 @@
              temperature       = pt(nzt+1,j,i) * t_d_pt(nzt+1) + l_d_cp *      &
                                  ql(nzt+1,j,i)
-             blackbody_emission(nzt+1) = sigma * temperature**4.0
+             blackbody_emission(nzt+1) = sigma * temperature**4
 
 !
@@ -267,5 +267,5 @@
 
        temperature     = pt(nzb,j,i) * t_d_pt(nzb) + l_d_cp * ql(nzb,j,i)
-       blackbody_emission(nzb) = sigma * temperature**4.0
+       blackbody_emission(nzb) = sigma * temperature**4
 
        DO  k = nzb_2d(j,i)+1, nzt
@@ -277,5 +277,5 @@
 
           temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
-          blackbody_emission(k) = sigma * temperature**4.0
+          blackbody_emission(k) = sigma * temperature**4
 
        ENDDO
@@ -286,5 +286,5 @@
        temperature       = pt(nzt+1,j,i) * t_d_pt(nzt+1) + l_d_cp *            &
                            ql(nzt+1,j,i)
-       blackbody_emission(nzt+1) = sigma * temperature**4.0
+       blackbody_emission(nzt+1) = sigma * temperature**4
 
 !
